%{!?kernel: %{expand: %%define kernel %(uname -r)}}
%define kversion %(echo %{kernel} | sed -e s/smp// -)
%define kernel_ver_str %(echo %{kversion} | tr -s '-' '_')

%define kmajor %(echo %{kversion} | cut -d'-' -f1 |cut -d'.' -f1)
%define kminor %(echo %{kversion} | cut -d'-' -f1 |cut -d'.' -f2)
%define kextra %(echo %{kversion} | cut -d'-' -f2)
%if %(echo %{kernel} | grep -c smp)
        %{expand:%%define ksmp -smp}
%endif
%define kconfig  /usr/src/linux-%(echo %{kernel})/configs/kernel-%{kmajor}-i686%{?ksmp}.config

%define mname madwifi
%define mversion 060704
%define mrelease 1.PU_IAS.9

Name: intelgraphics
Version: %{mversion}
Release: %{mrelease}
License: Other
Source: %{name}_%{version}.tar.gz
Patch0: GNUmakefile.patch
BuildRoot: %{_tmppath}/%{name}-root
Group: System Environment
Summary: XFree86 drivers for Intel 915G
BuildRequires: kernel-source, sharutils
AutoReqProv: 0

%description
** BUILT FOR PRIVATE PU_IAS USE, REDISTRIBUTION NOT ALLOWED **
        ** PU_IAS NOT RESPONSIBLE FOR REDISTRIBUTION **

XFree86 drivers for Intel 915G
To use, change the driver line in XF86Config to:

Driver      "i810"

or

redhat-config-xfree86 --reconfig 

do a modprobe -r agpgart if you are testing without a reboot.

%package -n kernel-%{name}
Release: %{mrelease}_%{kernel_ver_str}
License: Other
Summary: XFree86 drivers for Intel 915G
Group: System Environment
Requires: kernel = %{kversion}, %{name}
Provides: kernel-module kernel-modules

%description -n kernel-%{name}
** BUILT FOR PRIVATE PU_IAS USE, REDISTRIBUTION NOT ALLOWED **
        ** PU_IAS NOT RESPONSIBLE FOR REDISTRIBUTION **

XFree86 drivers for Intel 915G

%package -n kernel-smp-%{name}
Release: %{mrelease}_%{kernel_ver_str}
License: Other
Summary: XFree86 drivers for Intel 915G
Group: System Environment
Requires: kernel-smp = %{kversion}, %{name}
Provides: kernel-module kernel-modules

%description -n kernel-smp-%{name}
** BUILT FOR PRIVATE PU_IAS USE, REDISTRIBUTION NOT ALLOWED **
        ** PU_IAS NOT RESPONSIBLE FOR REDISTRIBUTION **
                                                                                                                             
XFree86 drivers for Intel 915G

%prep
%setup -q -n dripkg
%patch0 -p1 -b .gnumakefile
perl -pi -e "s|XXXXXYYYYY|%{kversion}|" agpgart/GNUmakefile

%build
echo kernel:%{kversion} - major:%{kmajor} - minor:%{kminor} - config:%{kconfig}
cp -ar /usr/src/linux-%{kversion} .
cd linux-%{kversion}
	perl -pi -e 's#%{kextra}custom#%{kextra}#' Makefile
	make distclean >/dev/null
	cp -f configs/kernel-%(echo %{kversion}|cut -d'-' -f1)-%{_target_cpu}.config .config
	make symlinks oldconfig >/dev/null
	make dep >/dev/null
cd ..
export KERNEL_VER=%{kversion}
export KERNEL_MAJOR=%{kmajor}
export KERNEL_MINOR=%{kminor}

export KSRC=linux-%{kversion}

if [ %{kminor} == "4" ]; then
	cd agpgart
		make clean >/dev/null
		make >/dev/null
	cd ..
	KERNEL_EXT="o"
fi
if [ %{kminor} == "6" ]; then
	cd agpgart-2.0
		make clean >/dev/null
		make >/dev/null
	cd ..
	KERNEL_EXT="ko"
fi

DRV_MODULE=`echo "5 p" | ed -s pkginfo`
export LINUXDIR=`pwd`/linux-%{kversion}
cd drm
	make -f Makefile.linux clean $DRV_MODULE.$KERNEL_EXT 
cd ..

#copy uniprocessor files
mkdir done-up
if [ %{kminor} == "4" ]; then
	cp agpgart/agpgart.o done-up
	cp drm/$DRV_MODULE.o done-up
fi
if [ %{kminor} == "6" ]; then
	cp agpgart-2.0/agp.ko
	cp drm/$DRV_MODULE.o done-up
fi

#start smp build
rm -rf linux-%{kversion}
cp -ar /usr/src/linux-%{kversion} .
cd linux-%{kversion}
	make distclean >/dev/null
	cp -f configs/kernel-%(echo %{kversion}|cut -d'-' -f1)-%{_target_cpu}-smp.config .config
	make symlinks oldconfig
	make dep >/dev/null
cd ..
export KERNEL_VER=%{kversion}
export KERNEL_MAJOR=%{kmajor}
export KERNEL_MINOR=%{kminor}
export KSRC=linux-%{kversion}smp

if [ %{kminor} == "4" ]; then
	cd agpgart
		make clean >/dev/null
		perl -pi -e "s|SMP=0|SMP=1|" GNUmakefile
		make >/dev/null
	cd ..
	KERNEL_EXT="o"
fi
if [ %{kminor} == "6" ]; then
	cd agpgart-2.0
		make clean >/dev/null
		make >/dev/null
	cd ..
	KERNEL_EXT="ko"
fi

DRV_MODULE=`echo "5 p" | ed -s pkginfo`
export LINUXDIR=`pwd`/linux-%{kversion}
cd drm
	make -f Makefile.linux clean $DRV_MODULE.$KERNEL_EXT 
cd ..

mkdir done-smp
if [ %{kminor} == "4" ]; then
	cp agpgart/agpgart.o done-smp
	cp drm/$DRV_MODULE.o done-smp
fi
if [ %{kminor} == "6" ]; then
	cp agpgart-2.0/agp.ko
	cp drm/$DRV_MODULE.o done-smp
fi

%install
#up
install -d -m 755 $RPM_BUILD_ROOT/lib/modules/%{kversion}/updates/drivers/char/agp
install -d -m 755 $RPM_BUILD_ROOT/lib/modules/%{kversion}/updates/drivers/char/drm
install -m 644 done-up/agpgart.o $RPM_BUILD_ROOT/lib/modules/%{kversion}/updates/drivers/char/agp
install -m 644 done-up/gdg.o $RPM_BUILD_ROOT/lib/modules/%{kversion}/updates/drivers/char/drm/
#smp
install -d -m 755 $RPM_BUILD_ROOT/lib/modules/%{kversion}smp/updates/drivers/char/agp
install -d -m 755 $RPM_BUILD_ROOT/lib/modules/%{kversion}smp/updates/drivers/char/drm
install -m 644 done-smp/agpgart.o $RPM_BUILD_ROOT/lib/modules/%{kversion}smp/updates/drivers/char/agp/
install -m 644 done-smp/gdg.o $RPM_BUILD_ROOT/lib/modules/%{kversion}smp/updates/drivers/char/drm/

#static
install -d -m 755 $RPM_BUILD_ROOT/usr/X11R6/lib
install -m 644 GL/libGL.so.1.2 $RPM_BUILD_ROOT/usr/X11R6/lib/libGL.intel.so.1.2 
install -d -m 755 $RPM_BUILD_ROOT/usr/X11R6/lib/modules/dri
install -d -m 755 $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers
install -m 644 gdg/gdg_dri.so $RPM_BUILD_ROOT/usr/X11R6/lib/modules/dri/
install -m 644 gdg/i810_drv.o $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers/i810_drv.intel.o

%post
#link to new GL lib
if [ -f /usr/X11R6/lib/libGL.so.1.2 ]; then
	mv -f /usr/X11R6/lib/libGL.so.1.2 /usr/X11R6/lib/libGL.so.1.2.old
fi
ln -s /usr/X11R6/lib/libGL.intel.so.1.2 /usr/X11R6/lib/libGL.so.1.2
#link to new i810_drv
if [ -f /usr/X11R6/lib/modules/drivers/i810_drv.o ]; then
	mv -f /usr/X11R6/lib/modules/drivers/i810_drv.o /usr/X11R6/lib/modules/drivers/i810_drv.o.old
fi
ln -s /usr/X11R6/lib/modules/drivers/i810_drv.intel.o /usr/X11R6/lib/modules/drivers/i810_drv.o


%postun
#remove link
if [ -L /usr/X11R6/lib/libGL.so.1.2 ] && [ -f /usr/X11R6/lib/libGL.so.1.2.old ]; then
	rm -f /usr/X11R6/lib/libGL.so.1.2
	mv -f /usr/X11R6/lib/libGL.so.1.2.old /usr/X11R6/lib/libGL.so.1.2
fi
if [ -L /usr/X11R6/lib/modules/drivers/i810_drv.o ] && [ -f /usr/X11R6/lib/modules/drivers/i810_drv.o.old ]; then
	rm -f /usr/X11R6/lib/modules/drivers/i810_drv.o
	mv -f /usr/X11R6/lib/modules/drivers/i810_drv.o.old /usr/X11R6/lib/modules/drivers/i810_drv.o
fi

%post -n kernel-%{name}
/sbin/depmod -ae

%post -n kernel-smp-%{name}
/sbin/depmod -ae

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc install.sh pkginfo
/usr/X11R6/lib/libGL.intel.so.1.2
/usr/X11R6/lib/modules/dri/*
/usr/X11R6/lib/modules/drivers/i810_drv.intel.o

%files -n kernel-%{name}
%defattr(-,root,root)
/lib/modules/%{kversion}/updates/drivers/char/agp/*
/lib/modules/%{kversion}/updates/drivers/char/drm/*

%files -n kernel-smp-%{name}
%defattr(-,root,root)
/lib/modules/%{kversion}smp/updates/drivers/char/agp/*
/lib/modules/%{kversion}smp/updates/drivers/char/drm/*

%changelog
* Tue Nov 29 2004 Thomas Uphill <uphill@math.ias.edu>
- fixes numerous non smp problems with module building.

* Tue Nov 02 2004 Thomas Uphill <uphill@math.ias.edu>
- fixed a few mistakes in post, installing smp modules everywhere.

* Wed Oct 27 2004 Thomas Uphill <uphill@math.ias.edu>
- updated libGL replacement, moved to post.

* Fri Oct 22 2004 Thomas Uphill <uphill@math.ias.edu>
- initial build, taken from Intel site and replicated install.sh script
